#include "generic_object.h"
#include "bmf.h"


/**********
* Render the object, ignoring position and orientation. I.e. draw the
* object wherever the current (MODELVIEW) matrix dictates.
**********/
void generic_object_t::draw_here(void)
{
	glPushAttrib(GL_ALL_ATTRIB_BITS);
	glCallList(list_num);
	glPopAttrib();
}


generic_object_t::generic_object_t(GLfloat init_pos_x,
		GLfloat init_pos_y,
		GLfloat init_pos_z,
		GLfloat lookat_x,
		GLfloat lookat_y,
		GLfloat lookat_z,
		GLfloat up_x,
		GLfloat up_y,
		GLfloat up_z) :
				scene_object_t(init_pos_x, init_pos_y, init_pos_z,
				lookat_x, lookat_y, lookat_z, up_x, up_y, up_z)
{
	BMFObject *obj;

	obj = LoadBMF("models/graveyrd.bmf");
	list_num = glGenLists(1);
	glNewList(list_num, GL_COMPILE);
		DrawBMFObject(obj);
//		glutSolidCube(1);
	glEndList();
	free(obj);
}


generic_object_t::~generic_object_t()// : ~scene_object_t()
{
	// Free display list for future use.
	glDeleteLists(list_num, 1);
}