#include <stdio.h>
#include "misc.h"

/* Lifted shamelessly from a newsgroup message posted by Nate Robbins.
 *
 * text: general purpose text routine.  draws a string according to
 * format in a stroke font at x, y after scaling it by the scale
 * specified (scale is in window-space (lower-left origin) pixels).  
 *
 * x      - position in x (in window-space)
 * y      - position in y (in window-space)
 * scale  - scale in pixels
 * format - as in printf()
 */
void text(GLuint x, GLuint y, GLfloat scale, char* format, ...)
{
	va_list args;
	char buffer[255], *p;
	GLfloat font_scale = 119.05f + 33.33f;   /* as described in the GLUT spec. */

	va_start(args, format);
	vsprintf(buffer, format, args);
	va_end(args);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0, glutGet(GLUT_WINDOW_WIDTH), 0, glutGet(GLUT_WINDOW_HEIGHT));

	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();

	glPushAttrib(GL_ENABLE_BIT);
	glDisable(GL_LIGHTING);
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_DEPTH_TEST);
	glTranslatef(x, y, 0.0);

	glScalef(scale/font_scale, scale/font_scale, scale/font_scale);

	for(p = buffer; *p; p++)
		glutStrokeCharacter(GLUT_STROKE_ROMAN, *p);
  
	glPopAttrib();

	glPopMatrix();
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}