/**********
* Miscellaneous math functions.
**********/

#ifndef _MORE_MATH_H
#define _MORE_MATH_H


#include <GL/glut.h>
#include <math.h>

#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif
#define MAX(x,y)		(y)>(x)?(y):(x)
#define MIN(x,y)		(y)<(x)?(y):(x)
#define INFINITY		RAND_MAX	// change this
#define FLOAT_INFINITY	99999.0f;	// change this

//GLfloat sin_table[180];	// Need to init this
//GLfloat cos_table[180];	// Need to init this

void invert_matrix( const GLfloat *m, GLfloat *out );
void cross_product(GLfloat *out, GLfloat *v1, GLfloat *v2);
void normalize_vector(GLfloat *vect);
GLfloat vector_length(GLfloat *vect);
/**/GLfloat fast_sin(GLfloat);
/**/GLfloat fast_cos(GLfloat);


#endif