#include "timer.h"
#include <GL/glut.h>


/**********
* Globals
**********/
/*static int last_time = glutGet(GLUT_ELAPSED_TIME);
static int current_time = 0;
static int elapsed_time = 0;*/
static DWORD last_time = timeGetTime();
static DWORD current_time;
static int elapsed_time;


/**********
* Update timer values. This should be called regularly in order to
* maintain accuracy. Typically, called at beginning (or end) of main
* game logic loop.
**********/
void update_timer()
{
/*	current_time = glutGet(GLUT_ELAPSED_TIME);
	if ( (elapsed_time = current_time - last_time) == 0)
		elapsed_time = 1;*/
	current_time = timeGetTime();
	elapsed_time = int(current_time - last_time);
	last_time = current_time;
}


/**********
* Return elapsed time since last call to update_timer().
*
* Return Value
*	Elapsed time in number of milliseconds.
**********/
int get_elapsed_time()
{
	return (int)elapsed_time;
}


/**********
* Get the frames-per-second.
**********/
float get_fps()
{
	if (elapsed_time)
		return 1.0 / ((float)elapsed_time / 1000.0);
	else
		return (float)999.9;
}
