/**********
* A game world (or level).
**********/

#ifndef _WORLD_H
#define _WORLD_H


#include <GL/glut.h>
#include "camera.h"
#include "world_object.h"


#define MOUSE_MARGIN		20	// Margin size defining where mouse is allowed.
#define DEFAULT_ROTATE_SPEED	90.0f	// When unspecified by objects in world.
#define DEFAULT_MOVE_SPEED	4.0f
#define CAMERA_ROTATE_SPEED	90.0f
#define CAMERA_MOVE_SPEED	3.0f
#define MOUSE_SENSITIVITY	0.1f	// 0.0 (lowest) to 1.0 (highest).


class world_t {
public:
	void process_input();
/**/	void update();
	void suspend();
	void resume();
	int is_suspended();
	void draw();
	void reset();
/**/	void save(char *filename);
/**/	void load(char *filename);
	world_t();
	~world_t();

private:
	void mouse_motion();
	void keystrokes();
	int is_paused;
	camera_t *camera;
	world_object_t *obj;
};


#endif